<?php

if (!function_exists('translateKeyWord')) {
    /**
     * Translate special key work
     * @param $keyWord
     * @return mixed
     */
    function translateKeyWord($keyWord)
    {
        if (empty($keyWord)) {
            return $keyWord;
        } else {
            return str_replace(['%'], ['\%'], $keyWord);
        }
    }
}

if (!function_exists('sendRequest')) {
    function sendRequest($url, $params = array(), $method = 'POST', $isJSON = true, $isAuthen = false, $timeOut = 60)
    {
        $request = \Ixudra\Curl\Facades\Curl::to($url)
            ->withOption('TIMEOUT', $timeOut)
            ->withOption('CONNECTTIMEOUT', 0)
            ->withOption('SSL_VERIFYPEER', 0)
            ->withContentType('application/json')
            ->withOption('FOLLOWLOCATION', true)
            ->returnResponseObject();

        if ($isJSON) {
            $request->withData(json_encode($params));
        } else {
            $request->withData($params);
        }

        if ($isAuthen) {
            $request->withOption('USERPWD', 'admin:weppoHER4352GGErfg');
        }

        $response = '';
        switch ($method) {
            case 'GET':
                $response = $request->get();
                break;
            case 'POST':
                $response = $request->post();
                break;
            case 'PUT':
                $response = $request->put();
                break;
            case 'PATCH':
                $response = $request->patch();
                break;
            case 'DELETE':
                $response = $request->delete();
                break;
            default:
                break;
        }

        return $response->content;
    }
}

if (!function_exists('getDom')) {
    function getDom($link)
    {
        $ch = curl_init($link);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $content = curl_exec($ch);
        curl_close($ch);
        $dom = \Sunra\PhpSimple\HtmlDomParser::str_get_html($content);

        return $dom;
    }
}

if (!function_exists('curlZingMp3')) {
    function curlZingMp3($url) {
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');

        curl_setopt($ch, CURLOPT_ENCODING, 'gzip, deflate');

        $headers = array();
        $headers[] = 'Authority: mp3.zing.vn';
        $headers[] = 'Cache-Control: max-age=0';
        $headers[] = 'Upgrade-Insecure-Requests: 1';
        $headers[] = 'User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36';
        $headers[] = 'Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3';
        $headers[] = 'Accept-Encoding: gzip, deflate, br';
        $headers[] = 'Accept-Language: vi-VN,vi;q=0.9,en-US;q=0.8,en;q=0.7,ja;q=0.6';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            return false;
        }
        curl_close ($ch);
        return $result;
    }
}

if (!function_exists('curlZingArtist')) {
    function curlZingArtist($url) {
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');

        curl_setopt($ch, CURLOPT_ENCODING, 'gzip, deflate');

        $headers = array();
        $headers[] = 'Authority: zingmp3.vn';
        $headers[] = 'Cache-Control: max-age=0';
        $headers[] = 'Upgrade-Insecure-Requests: 1';
        $headers[] = 'User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36';
        $headers[] = 'Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3';
        $headers[] = 'Accept-Encoding: gzip, deflate, br';
        $headers[] = 'Accept-Language: vi-VN,vi;q=0.9,en-US;q=0.8,en;q=0.7,ja;q=0.6';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            return false;
        }
        curl_close ($ch);
        return $result;
    }
}

if (!function_exists('getUrlArtistByPage')) {
    function getUrlArtistByPage($start=1, $count=100) {
        $url = 'https://zingmp3.vn/api/artist/get-list?';
        $url .= 'id=IWZ9Z08I';
        $url .= '&type=genre';
        $url .= '&sort=listen';
        $url .= '&start=' . $start;
        $url .= '&count=' . $count;
        $url .= '&ctime=1584216597';
        $url .= '&sig=e2b8e1e48ccd12f560959913a6901fc76c9b93e1cafecba2d3517d8ab57eeb44717aa41eca70338bcf8bc8c84def1c43367ef44c887589db4ed81a1e2c042303';
        $url .= '&api_key=38e8643fb0dc04e8d65b99994d3dafff';

        return $url;
    }
}

if (!function_exists('cURL')) {
    function cURL($url) {
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');

        curl_setopt($ch, CURLOPT_ENCODING, 'gzip, deflate');

        //$headers = array();
        //$headers[] = 'Authority: mp3.zing.vn';
        //$headers[] = 'Cache-Control: max-age=0';
        //$headers[] = 'Upgrade-Insecure-Requests: 1';
        //$headers[] = 'User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36';
        //$headers[] = 'Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3';
        //$headers[] = 'Accept-Encoding: gzip, deflate, br';
        //$headers[] = 'Accept-Language: vi-VN,vi;q=0.9,en-US;q=0.8,en;q=0.7,ja;q=0.6';
        //curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            return false;
        }
        curl_close ($ch);
        return $result;
    }
}

if (!function_exists('getZingUrlGetCounter')) {
    /**
     * Hàm tạo URL cho từng bài hát dựa vào ID chuỗi của nó để lấy lượt nghe
     * https://mp3.zing.vn/xhr/get-counter?id='. $idTrack .'&type=audio
     *
     * @param $id_str
     * @param string $type
     * @return string
     */
    function getZingUrlGetCounter($id_str, $type='audio') {
        $url = 'https://mp3.zing.vn/xhr/get-counter?';
        $url .= 'id=' . $id_str;
        $url .= '&type=' . $type;

        return $url;
    }
}

if (!function_exists('getNctUrlGetCounter')) {
    /**
     * Hàm tạo URL cho từng bài hát dựa vào ID của nó để lấy lượt nghe
     * https://www.nhaccuatui.com/interaction/api/counter?listSongIds=6238530
     *
     * @param $id
     * @return string
     */
    function getNctUrlGetCounter($id) {
        $url = 'https://www.nhaccuatui.com/interaction/api/counter?';
        $url .= 'listSongIds=' . $id;

        return $url;
    }
}

if (!function_exists('getKeengUrlGetCounter')) {
    /**
     * Hàm tạo URL cho từng bài hát dựa vào ID của nó để lấy lượt nghe
     * http://vip.service.keeng.vn:8080/KeengWSRestful///ws/common/getSong?identify=IGm9Y2XF
     *
     * @param $id
     * @return string
     */
    function getKeengUrlGetCounter($id) {
        $url = 'http://vip.service.keeng.vn:8080/KeengWSRestful///ws/common/getSong?';
        $url .= 'identify=' . $id;

        return $url;
    }
}

if (!function_exists('getKeengUrlCategoryByPopViet')) {
    /**
     * Hàm tạo URL để lấy thông tin bài hát theo chủ đề Pop Việt
     * http://vip.service.keeng.vn:8080/KeengWSRestful///ws/common/getCategoryDetail?page=100&num=100&slug=pop-viet&type=1
     *
     * @param $page
     * @param $num
     * @param $slug
     * @param $type
     * @return string
     */
    function getKeengUrlCategoryByPopViet($page = 1, $num = 100, $slug = 'pop-viet', $type = 1) {
        $url = 'http://vip.service.keeng.vn:8080/KeengWSRestful///ws/common/getCategoryDetail?';
        $url .= 'page=' . $page;
        $url .= '&num=' . $num;
        $url .= '&slug=' . $slug;
        $url .= '&type=' . $type;

        return $url;
    }
}

if (!function_exists('getKeengUrlNewRealease')) {
    /**
     * Hàm tạo URL để lấy thông tin bài hát theo chủ đề Pop Việt
     * http://vip.service.keeng.vn:8080/KeengWSRestful///ws/common/getListSongNewV4?page=1&num=40
     *
     * @param $page
     * @param $num
     * @return string
     */
    function getKeengUrlNewRealease($page = 1, $num = 100) {
        $url = 'http://vip.service.keeng.vn:8080/KeengWSRestful///ws/common/getListSongNewV4?';
        $url .= 'page=' . $page;
        $url .= '&num=' . $num;

        return $url;
    }
}
